//TODO: check for integer overflow (should use long)

import java.io.*;
import java.util.*;

public class elevator_ai_slow {
	class Query {
		int time, floor;
		int served;
		int next;
		Query(int time, int floor) {
			this.time = time; this.floor = floor;
			this.served = -1;
			this.next = -1;
		}
	}
	
	static final int MAXN = 100000;
	static final int MAXM = 100000;
	static final int MAXA = 100;
	static final int MAXB = 100;
	static final int MAXT = 1000000000;
	
	void run() throws Exception {
		System.out.println("Slow solution: started");
		long timeStarted = new Date().getTime();
		
		BufferedReader in = new BufferedReader(new FileReader("elevator.in"));
		StringTokenizer st = new StringTokenizer(in.readLine());
		int n = Integer.parseInt(st.nextToken());
		int m = Integer.parseInt(st.nextToken());
		int a = Integer.parseInt(st.nextToken());
		int b = Integer.parseInt(st.nextToken());
		assert (1 <= n) && (n <= MAXN) : "Wrong N value";
		assert (1 <= m) && (m <= MAXM) : "Wrong M value";
		assert (1 <= a) && (a <= MAXA) : "Wrong A value";
		assert (1 <= b) && (b <= MAXB) : "Wrong B value";
		Query[] q = new Query[m];
		int[] f = new int[n];
		int[] l = new int[n];
		Arrays.fill(f, -1);
		Arrays.fill(l, -1);
		for (int i = 0; i < m; ++i) {
			st = new StringTokenizer(in.readLine());
			q[i] = new Query(Integer.parseInt(st.nextToken()), Integer.parseInt(st.nextToken()) - 1);
			assert (1 <= q[i].time) && (q[i].time <= MAXT) : "Wrong query " + i + " time value";
			assert (0 <= q[i].floor) && (q[i].floor <= n - 1) : "Wrong query " + i + " floor value";
			if (l[q[i].floor] == -1) f[q[i].floor] = l[q[i].floor] = i;
			else {
				q[l[q[i].floor]].next = i;
				l[q[i].floor] = i;
			}
		}
		in.close();
		
		System.out.println(" reading finished");
		
		int timeStayed = 0, time = 0, floor = 0;
		for (int i = 0; i < m; ++i) if (q[i].served == -1) {
//			if ((i & 31) == 0) System.out.print(".");
			assert f[q[i].floor] == i : "Floor " + q[i].floor + " queries list doesn't begin with current query " + i;
			timeStayed += Math.max(0, q[i].time - time);
			time = Math.max(time, q[i].time);
			if (q[i].floor != floor) { 
				int direction = (q[i].floor > floor ? 1 : (q[i].floor < floor ? -1 : 0));
				while (floor != q[i].floor) {
					while ((f[floor] != -1) && (q[f[floor]].time <= time)) {
						q[f[floor]].served = time;
						time += a;
						f[floor] = q[f[floor]].next;
					}
					floor += direction;
					time += b;
				}
			}
			q[i].served = time;
			time += a;
			f[q[i].floor] = q[i].next;
		}
		int timeMoved = time - timeStayed - m * a;

		System.out.println("\n solving finished");

		PrintWriter out = new PrintWriter(new FileWriter("elevator.out"));
//		out.println("Elevator was remaining motionless during " + timeStayed + " seconds");
//		out.println("and was moving during " + timeMoved + " seconds.");
		for (int i = 0; i < m; ++i) {
			out.println(q[i].served);
		}
		out.close();

		System.out.println("Slow solution finished in " + (new Date().getTime() - timeStarted)+ "ms");
	}
	
	public static void main(String[] args) throws Exception {
		new elevator_ai_slow().run();
	}
}
