#include <algorithm>
#include <cstdio>
#include "random.h"

using namespace std;

int n, m;
int e[202400][3];
int p[102400];

void addcycle(int k)
{
	int n0 = rndInt(2) + 1;
	if (n0 > n) n0 = n;
	e[m][0] = n0;
	e[m][1] = ++n;
	m++;
	for(int i = 2; i < k; i++)
	{
		e[m][0] = n;
		e[m][1] = ++n;
		m++;
	}
	e[m][0] = n;
	e[m][1] = n0;
	m++;
}

void addchain(int k)
{
	int n0 = rndInt(2) + 1;
	if (n0 > n) n0 = n;
	e[m][0] = n0;
	e[m][1] = ++n;
	m++;
	for(int i = 1; i < k; i++)
	{
		e[m][0] = n;
		e[m][1] = ++n;
		m++;
	}
}

void shuffle()
{
	for(int i = 1; i <= n; i++)
	{
		p[i] = i;
	}
	for(int i = 1; i <= n; i++)
	{
		swap(p[i], p[rndInt(n) + 1]);
	}
	for(int i = 0; i < m; i++)
	{
		e[i][0] = p[e[i][0]];
		e[i][1] = p[e[i][1]];
	}
}

int main()
{
	freopen("05", "wt", stdout);

	initrand(23552);

	n = 1;
	m = 0;
	addchain(2);
	while (n < 99997)
	{
		int k = rndInt(2) + 3;
		if (rndInt(2) == 0) addcycle(k);
		else addchain(k);
	}
	shuffle();

	printf("%d %d\n", n, m);
	for(int i = 0; i < m; i++)
	{
		e[i][2] = rndInt(5) + 1;
		printf("%d %d %d\n", e[i][0], e[i][1], e[i][2]);
	}
	int k = 100000;
	printf("%d\n", k);
	for(int i = 0; i < k; i++)
	{
		if (rndInt(100) != 2)
		{
			printf("R %d %d\n", 1, rndInt(10005) + 1);
		}
		else if (rndInt(12) == 1)
		{
			printf("R %d %d\n", rndInt(m) + 1, rndInt(55) + 1);
		}
		else
		{
			printf("P %d %d\n", rndInt(n) + 1, rndInt(n) + 1);
		}
	}

	return 0;
}
