#include <algorithm>
#include <cstdio>
#include "random.h"

using namespace std;

int n, m;
int e[202400][3];
int p[102400];

void addcycle(int k)
{
	int n0 = n;//rndInt(n) + 1;
	e[m][0] = n0;
	e[m][1] = ++n;
	m++;
	for(int i = 2; i < k; i++)
	{
		e[m][0] = n;
		e[m][1] = ++n;
		m++;
	}
	e[m][0] = n;
	e[m][1] = n0;
	m++;
}

void addchain(int k)
{
	int n0 = n;//rndInt(n) + 1;
	e[m][0] = n0;
	e[m][1] = ++n;
	m++;
	for(int i = 1; i < k; i++)
	{
		e[m][0] = n;
		e[m][1] = ++n;
		m++;
	}
}

void shuffle()
{
	for(int i = 1; i <= n; i++)
	{
		p[i] = i;
	}
	for(int i = 1; i <= n; i++)
	{
		swap(p[i], p[rndInt(n) + 1]);
	}
	for(int i = 0; i < m; i++)
	{
		e[i][0] = p[e[i][0]];
		e[i][1] = p[e[i][1]];
	}
	for(int i = 0; i < m; i++)
	{
		int j = rndInt(m);
		swap(e[i][0], e[j][0]);
		swap(e[i][1], e[j][1]);
		swap(e[i][2], e[j][2]);
	}
}

int main()
{
	freopen("10", "wt", stdout);

	initrand(123917);

	n = 1;
	m = 0;
	while (n < 99990)
	{
		int k = rndInt(4) + 5;
		if (rndInt(2) == 0) addcycle(k);
		else addchain(k);
	}
	shuffle();

	printf("%d %d\n", n, m);
	for(int i = 0; i < m; i++)
	{
		e[i][2] = rndInt(5) + 1;
		printf("%d %d %d\n", e[i][0], e[i][1], e[i][2]);
	}
	int k = 100000;
	printf("%d\n", k);
	for(int i = 0; i < k; i++)
	{
		if (rndInt(2) == 1)
		{
			printf("R %d %d\n", rndInt(m) + 1, rndInt(10) + 12);
		}
		else
		{
			printf("P %d %d\n", rndInt(n) + 1, rndInt(n) + 1);
		}
	}

	return 0;
}
