#include <algorithm>
#include <cstdio>
#include "random.h"

using namespace std;

int n, m;
int e[202400][3];
int p[102400];

void addcycle(int k, int v0 = 1)
{
	int n0 = v0;
	e[m][0] = n0;
	e[m][1] = ++n;
	m++;
	for(int i = 2; i < k; i++)
	{
		e[m][0] = n;
		e[m][1] = ++n;
		m++;
	}
	e[m][0] = n;
	e[m][1] = n0;
	m++;
}

void addchain(int k, int v0)
{
	int n0 = v0;
	if (n0 > n) n0 = n;
	e[m][0] = n0;
	e[m][1] = ++n;
	m++;
	for(int i = 1; i < k; i++)
	{
		e[m][0] = n;
		e[m][1] = ++n;
		m++;
	}
}

void go(int v)
{
	int t = n;
	while (n - t < 9960)
	{
		if (rndInt(3) == 0)
		{
			addchain(rndInt(3) + 1, v);
			v = n;
		}
		else
		{
			addcycle(3, v);
			v = n;
			addcycle(3, v);
			addcycle(3, v);
			v = n;
		}
	}
}

void shuffle()
{
	for(int i = 1; i <= n; i++)
	{
		p[i] = i;
	}
	for(int i = 1; i <= n; i++)
	{
		swap(p[i], p[rndInt(n) + 1]);
	}
	for(int i = 0; i < m; i++)
	{
		e[i][0] = p[e[i][0]];
		e[i][1] = p[e[i][1]];
	}
	for(int i = 0; i < m; i++)
	{
		int j = rndInt(m);
		swap(e[i][0], e[j][0]);
		swap(e[i][1], e[j][1]);
		swap(e[i][2], e[j][2]);
	}
}

int main()
{
	freopen("16", "wt", stdout);

	initrand(81956832);

	n = 1;
	m = 0;
	int k1 = 12653;
	int k2 = 14201;
	int k3 = 11045;
	addcycle(k1);
	addcycle(k2);
	addcycle(k3);
	for(int i = 0; i <= 487; i++)
	{
		addcycle(3 + rndInt(5));
	}
	int n1 = n;
	while (n < 69990)
	{
		int v = -1;
		if (rndInt(3) == 0) v = k1 / 2;
		else if (rndInt(2) == 0) v = k1 + k2 / 2;
		else v = k1 + k2 + k3 / 2;

		v += rndInt(2001) - 1000;

		int k = 3 + rndInt(5);
		addcycle(k, v);
	}
	int n2 = n;

	for(int i = 0; i < 3; i++)
	{
		int v = n1 + rndInt(n2 - n1) + 1;
		go(v);
	}
	shuffle();

	printf("%d %d\n", n, m);
	for(int i = 0; i < m; i++)
	{
		e[i][2] = 20 + rndInt(2525);
		printf("%d %d %d\n", e[i][0], e[i][1], e[i][2]);
	}
	int k = 100000;
	printf("%d\n", k);
	for(int i = 0; i < k; i++)
	{
		if (i % 12 < 3)
		{
			if (i % 12 == 3) printf("R %d %d\n", rndInt(m) + 1, rndInt(min(i + 215, 90015)) + 1);
			else printf("R %d %d\n", rndInt(m) + 1, rndInt(min(i + 2, 98015)) + 1);
		}
		else
		{
			printf("P %d %d\n", p[k1 + k2 + k3 + rndInt(n - k1 - k2 - k3) + 1], p[k1 + k2 + k3 + rndInt(n - k1 - k2 - k3) + 1]);
		}
	}

	return 0;
}
