#include <algorithm>
#include <cstdio>
#include "random.h"

using namespace std;

int n, m;
int e[202400][3];
int p[102400];

void addcycle(int k, int v0 = 1)
{
	int n0 = v0;
	e[m][0] = n0;
	e[m][1] = ++n;
	m++;
	for(int i = 2; i < k; i++)
	{
		e[m][0] = n;
		e[m][1] = ++n;
		m++;
	}
	e[m][0] = n;
	e[m][1] = n0;
	m++;
}

void addchain(int k, int v0)
{
	int n0 = v0;
	if (n0 > n) n0 = n;
	e[m][0] = n0;
	e[m][1] = ++n;
	m++;
	for(int i = 1; i < k; i++)
	{
		e[m][0] = n;
		e[m][1] = ++n;
		m++;
	}
}

void go(int v)
{
	int t = n;
	while (n - t < 960)
	{
		if (rndInt(3) == 0)
		{
			addchain(rndInt(3) + 1, v);
			v = n;
		}
		else
		{
			addcycle(3, v);
			v = n;
			addcycle(3, v);
			addcycle(3, v);
			v = n;
		}
	}
}

void shuffle()
{
	for(int i = 1; i <= n; i++)
	{
		p[i] = i;
	}
	for(int i = 1; i <= n; i++)
	{
		swap(p[i], p[rndInt(n) + 1]);
	}
	for(int i = 0; i < m; i++)
	{
		e[i][0] = p[e[i][0]];
		e[i][1] = p[e[i][1]];
	}
	for(int i = 0; i < m; i++)
	{
		int j = rndInt(m);
		swap(e[i][0], e[j][0]);
		swap(e[i][1], e[j][1]);
		swap(e[i][2], e[j][2]);
	}
}

int main()
{
	freopen("17", "wt", stdout);

	initrand(513551);

	n = 1;
	m = 0;
	int k1 = 92653;
	addcycle(k1);
	for(int i = 0; i <= 87; i++)
	{
		addcycle(3 + rndInt(5));
	}
	int n1 = n;
	while (n < 96990)
	{
		int v = rndInt(n) + 1;

		int k = 3 + rndInt(5);
		addcycle(k, v);
	}
	int n2 = n;

	for(int i = 0; i < 3; i++)
	{
		int v = n1 + rndInt(n2 - n1) + 1;
		go(v);
	}
	shuffle();

	printf("%d %d\n", n, m);
	for(int i = 0; i < m; i++)
	{
		e[i][2] = 99920 + rndInt(75);
		printf("%d %d %d\n", e[i][0], e[i][1], e[i][2]);
	}
	int k = 100000;
	printf("%d\n", k);
	for(int i = 0; i < k; i++)
	{
		if (i % 12 < 6)
		{
			if (i % 12 == 3) printf("R %d %d\n", rndInt(m) + 1, rndInt(min(i + 215, 90015)) + 1);
			else printf("R %d %d\n", rndInt(m) + 1, rndInt(min(i + 2, 98015)) + 1);
		}
		else
		{
			if (i % 12 == 3)
			{
				printf("P %d %d\n", rndInt(n) + 1, rndInt(n) + 1);
			}
			else if (i % 11 <= 3)
			{
				int t = rndInt(k1);
				printf("P %d %d\n", p[t + 1], p[(t + k1/2) % k1 + 1]);
			}
			else if (i % 23 == 3)
			{
				int t = k1 + rndInt(200) + 1;
				int xx = p[t + 1];
				int yy = p[1 + k1/2 + rndInt(77) - 33 + 1];
				if (rndInt(2) == 1) swap(xx, yy);
				printf("P %d %d\n", xx, yy);
			}
			else
			{
				printf("P %d %d\n", p[k1 + rndInt(n - k1) + 1], p[k1 + rndInt(n - k1) + 1]);
			}
		}
	}

	return 0;
}
