#include <algorithm>
#include <cstdio>
#include <cstring>
#include <vector>

using namespace std;

#define sz size()
#define pb push_back
#define mp make_pair
#define clr(x) memset(x, 0, sizeof(x))
#define forn(i, n) for(int i = 0; i < (int)(n); i++)
#define For(i, st, en) for(int i = (st); i <= (int)(en); i++)

#if ( _WIN32 || __WIN32__ || _WIN64 || __WIN64__ )
#define INT64 "%I64d"
#else
#define INT64 "%Ld"
#endif



typedef long long i64;
typedef vector < int > VI;

struct PLI
{
	i64 first;
	int second;

	PLI() : first(0), second(0) {};
	PLI(i64 _first, int _second) : first(_first), second(_second) {};

	PLI operator += (const PLI &p)
	{
		first += p.first;
		second += p.second;
		return *this;
	}
};

const int MAXN = 102400;
const int MAXQ = 100000;

int n, m, k;
VI a[MAXN];
int e[MAXN * 2][3];
int u[MAXN];
int tn, tnc;
int t[MAXN];
int p[MAXN];
int pc[MAXN];
PLI *ti[MAXN * 2];
VI ts[MAXN * 2];
int tz[MAXN * 2];
int pa[MAXN];
int pal[MAXN];
int timein[MAXN];
int timeout[MAXN];
int tt, curTime;

VI cycles[MAXN];
int cyc_id[MAXN];
int path[MAXN];
VI topc[MAXN];
int vpath[MAXN];
int cyc_time[MAXN];
VI upd_cyc[MAXN];

int sum[MAXN];
int h[MAXN];

PLI operator + (const PLI &p1, const PLI &p2)
{
	return PLI(p1.first + p2.first, p1.second + p2.second);
}

inline int getV(int v, int i)
{
	return (e[a[v][i]][0] == v) ? e[a[v][i]][1] : e[a[v][i]][0];
}

void dfs(int k, int prev)
{
	u[k] = 1;
	pa[k] = prev;
	path[++path[0]] = k;

	forn(i, a[k].sz)
	{
		int j = getV(k, i);
		if (!u[j])
		{
			pal[j] = e[a[k][i]][2];
			dfs(j, k);
		}
		else if (u[j] == 1)
		{
			if (j != prev)
			{
				int t = path[0];
				topc[j].pb(tnc);
				cycles[tnc].pb(j);
				int y = 1;
				while (path[t] != j)
				{
					cycles[tnc].pb(path[t]);
					cyc_id[path[t]] = tnc;
					pc[path[t]] = y++;
					t--;
				}
				tnc++;
			}
		}
	}

	path[0]--;
	u[k] = 2;
}

void dfs2(int k)
{
	u[k] = 1;
	VI tmp;
	timein[k] = tt++;

	sum[k] = 1;
	forn(i1, topc[k].sz)
	{
		int i = topc[k][i1];
		forn(j, cycles[i].sz)
		{
			int v = cycles[i][j];
			u[v] = 1;
		}
		For(j, 1, cycles[i].sz - 1)
		{
			int v = cycles[i][j];
			dfs2(v);
			tmp.pb(v);
			sum[k] += sum[v];
		}
	}
	forn(i, a[k].sz)
	{
		int j = getV(k, i);
		if (!u[j])
		{
			dfs2(j);
			tmp.pb(j);
			sum[k] += sum[j];
		}
	}

	forn(i, tmp.sz)
	{
		int v = tmp[i];
		if (sum[v] * 2 > sum[k] - 1)
		{
			if (t[v] == -1)
			{
				t[v] = tn++;
				p[v] = 0;
				ts[t[v]].pb(v);
			}
			t[k] = t[v];
			p[k] = p[v] + 1;
			ts[t[k]].pb(k);
		}
	}
	timeout[k] = tt++;
}

void dfs3(int k)
{
	if (h[pa[k]] == -1)
	{
		dfs3(pa[k]);
	}
	h[k] = h[pa[k]] + 1;
}

void tinsert(int nt, int x, PLI k)
{
	x += tz[nt];
	PLI *t = ti[nt];
	t[x] = k;
	x >>= 1;
	while (x)
	{
		t[x] = t[x * 2] + t[x * 2 + 1];
		x >>= 1;
	}
}

PLI tsum(int nt, int l, int r)
{
	l += tz[nt];
	r += tz[nt];
	PLI *t = ti[nt];
	PLI ans;

	while (l <= r)
	{
		if (l & 1) ans += t[l];
		if (!(r & 1)) ans += t[r];
		l = (l + 1) >> 1;
		r = (r - 1) >> 1;
	}

	return ans;
}

void update_cycle_on_tree(int id)
{
	int j = vpath[id];
	PLI l1 = tsum(id, 0, j - 1);
	PLI l2 = tsum(id, j, cycles[id].sz - 1);
	PLI l = (l1.first + (i64)l1.second * curTime < l2.first + (i64)l2.second * curTime) ? l1 : l2;
	tinsert(t[cycles[id][j]], p[cycles[id][j]], l);
}

int update_cycle(int v1, int v2, int l)
{
	if (cyc_id[v1] == -1 && cyc_id[v2] == -1) return -1;
	int id = -1;
	if (cyc_id[v1] == cyc_id[v2])
	{
		id = cyc_id[v1];
	}
	else
	{
		if (cyc_id[v1] != -1 && cycles[cyc_id[v1]][0] == v2)
		{
			id = cyc_id[v1];
		}
		else if (cyc_id[v2] != -1 && cycles[cyc_id[v2]][0] == v1)
		{
			id = cyc_id[v2];
		}
	}
	if (id == -1) return id;

	int p1 = (cyc_id[v1] == id) ? pc[v1] : 0;
	int p2 = (cyc_id[v2] == id) ? pc[v2] : 0;
	if ((p1 + 1) % (int)cycles[id].sz == p2)
	{
		tinsert(id, p1, PLI(l, 1));
	}
	else
	{
		tinsert(id, p2, PLI(l, 1));
	}
	return id;
}

void update(int x)
{
	int v1 = e[x][0], v2 = e[x][1];
	if (pa[v1] == v2) pal[v1] = e[x][2];
	if (pa[v2] == v1) pal[v2] = e[x][2];
	int id = update_cycle(v1, v2, e[x][2]);
	PLI l;
	if (id != -1)
	{
		if (vpath[id] == -1) return;
		int j = vpath[id];
		PLI l1 = tsum(id, 0, j - 1);
		PLI l2 = tsum(id, j, cycles[id].sz - 1);
		v2 = cycles[id][vpath[id]];
		l = (l1.first + (i64)l1.second * curTime < l2.first + (i64)l2.second * curTime) ? l1 : l2;

		if (l1.first < l2.first) swap(l1, l2);
		i64 x = -1;
		if (l1.first == l2.first)
		{
			x = 1;
		}
		else if (l2.second > l1.second)
		{
			x = (l1.first - l2.first) / (l2.second - l1.second) + 1;
		}
		if (x >= 1 && x <= MAXQ)
		{
			cyc_time[id] = x;
			upd_cyc[x].pb(id);
		}
	}
	else
	{
		if (pa[v1] == v2) swap(v1, v2);
		if (t[v2] == -1) return;
		l = PLI(e[x][2], 1);
	}
	tinsert(t[v2], p[v2], l);
}

void precalc()
{
	memset(cyc_id, 0xff, sizeof(cyc_id));
	path[0] = 0;
	clr(u);
	tnc = 0;
	dfs(0, -1);

	forn(i, tnc)
	{
		forn(j, cycles[i].sz)
		{
			ts[i].pb(cycles[i][j]);
			if (j) pa[cycles[i][j]] = cycles[i][0];
		}
	}
	memset(t, 0xff, sizeof(t));
	tn = tnc;
	clr(u);
	tt = 0;
	dfs2(0);
	For(i, tnc, tn-1)
	{
		t[ts[i].back()] = -1;
	}
	memset(vpath, 0xff, sizeof(vpath));
	memset(cyc_time, 0xff, sizeof(cyc_time));
	forn(i, tnc)
	{
		For(j, 1, cycles[i].sz - 1)
		{
			if (t[cycles[i][j]] != -1)
			{
				vpath[i] = j;
			}
		}
	}

	memset(h, 0xff, sizeof(h));
	h[0] = 0;
	forn(i, n)
	{
		if (h[i] == -1) dfs3(i);
	}

	forn(i, tn)
	{
		tz[i] = 1;
		while (tz[i] < (int)ts[i].sz - (i >= tnc)) tz[i] <<= 1;
		ti[i] = new PLI[tz[i] * 2];
	}

	forn(i, m)
	{
		update(i);
	}
	forn(i, tnc)
	{
		if (vpath[i] == -1) continue;
		int j = vpath[i];
		PLI l1 = tsum(i, 0, j - 1);
		PLI l2 = tsum(i, j, cycles[i].sz - 1);
		if (l1.first < l2.first) swap(l1, l2);
		i64 x = -1;
		if (l1.first == l2.first)
		{
			x = 1;
		}
		else if (l2.second > l1.second)
		{
			x = (l1.first - l2.first) / (l2.second - l1.second) + 1;
		}
		if (x >= 1 && x <= MAXQ)
		{
			cyc_time[i] = x;
			upd_cyc[x].pb(i);
		}
	}
}

bool is_ancestor(int x, int y)
{
	return timein[x] <= timein[y] && timeout[x] >= timeout[y];
}

PLI calc_a(int x, int y)
{
	PLI ans;

	while (x != y)
	{
		int xup = (t[x] == -1) ? pa[x] : ts[t[x]].back();
		if (xup == -1) xup = 0;
		if (h[xup] < h[y])
		{
			int mi = p[x];
			int ma = ts[t[x]].sz - 1;
			while (mi < ma)
			{
				int q = (mi + ma + 1) >> 1;
				int v = ts[t[x]][q];
				if (is_ancestor(y, v))
				{
					mi = q;
				}
				else
				{
					ma = q - 1;
				}
			}
			ans += tsum(t[x], p[x], mi - 1);
			break;
		}

		if (t[x] == -1)
		{
			if (cyc_id[x] == -1)
			{
				ans += PLI(pal[x], 1);
			}
			else
			{
				PLI l1 = tsum(cyc_id[x], 0, pc[x] - 1);
				PLI l2 = tsum(cyc_id[x], pc[x], cycles[cyc_id[x]].sz - 1);
				ans += (l1.first + (i64)l1.second * curTime < l2.first + (i64)l2.second * curTime) ? l1 : l2;
			}
		}
		else
		{
			ans += tsum(t[x], p[x], ts[t[x]].sz - 2);
		}
		x = xup;
	}

	return ans;
}

PLI solve(int x, int y)
{
	PLI ans;

	while (x != y)
	{
		if (h[x] > h[y]) swap(x, y);
		if (is_ancestor(x, y))
		{
			ans += calc_a(y, x);
			break;
		}
		if (cyc_id[x] == cyc_id[y] && cyc_id[x] != -1)
		{
			int p1 = pc[x];
			int p2 = pc[y];
			if (p1 > p2) swap(p1, p2);
			PLI l1 = tsum(cyc_id[x], p1, p2 - 1);
			PLI l2 = tsum(cyc_id[x], 0, p1 - 1) + tsum(cyc_id[x], p2, cycles[cyc_id[x]].sz - 1);
			ans += (l1.first + (i64)l1.second * curTime < l2.first + (i64)l2.second * curTime) ? l1 : l2;
			break;
		}

		if (h[x] == h[y] && pa[x] == pa[y])
		{
			if (cyc_id[x] == -1)
			{
				ans += PLI(pal[x], 1);
			}
			else
			{
				PLI l1 = tsum(cyc_id[x], 0, pc[x] - 1);
				PLI l2 = tsum(cyc_id[x], pc[x], cycles[cyc_id[x]].sz - 1);
				ans += (l1.first + (i64)l1.second * curTime < l2.first + (i64)l2.second * curTime) ? l1 : l2;
			}
			if (cyc_id[y] == -1)
			{
				ans += PLI(pal[y], 1);
			}
			else
			{
				PLI l1 = tsum(cyc_id[y], 0, pc[y] - 1);
				PLI l2 = tsum(cyc_id[y], pc[y], cycles[cyc_id[y]].sz - 1);
				ans += (l1.first + (i64)l1.second * curTime < l2.first + (i64)l2.second * curTime) ? l1 : l2;
			}
			break;
		}

		int xup = (t[x] == -1) ? pa[x] : ts[t[x]].back();
		int yup = (t[y] == -1) ? pa[y] : ts[t[y]].back();
		if (xup == -1) xup = 0;
		if (yup == -1) yup = 0;
		if (h[xup] < h[yup])
		{
			swap(x, y);
			swap(xup, yup);
		}

		if (h[y] > h[x] && is_ancestor(yup, xup))
		{
			int mi = p[y];
			int ma = ts[t[y]].sz - 1;
			while (mi < ma)
			{
				int q = (mi + ma + 1) >> 1;
				int v = ts[t[y]][q];
				if (is_ancestor(v, xup))
				{
					ma = q - 1;
				}
				else
				{
					mi = q;
				}
			}
			ans += tsum(t[y], p[y], mi - 1);
			y = ts[t[y]][mi];
			continue;
		}

		if (t[x] == -1)
		{
			if (cyc_id[x] == -1)
			{
				ans += PLI(pal[x], 1);
			}
			else
			{
				PLI l1 = tsum(cyc_id[x], 0, pc[x] - 1);
				PLI l2 = tsum(cyc_id[x], pc[x], cycles[cyc_id[x]].sz - 1);
				ans += (l1.first + (i64)l1.second * curTime < l2.first + (i64)l2.second * curTime) ? l1 : l2;
			}
		}
		else
		{
			ans += tsum(t[x], p[x], ts[t[x]].sz - 2);
		}
		x = xup;
	}

	return ans;
}

int main()
{
	scanf("%d%d", &n, &m);
	forn(i, m)
	{
		forn(j, 3)
		{
			scanf("%d", &e[i][j]);
		}
		e[i][0]--;
		e[i][1]--;
		a[e[i][0]].pb(i);
		a[e[i][1]].pb(i);
	}
	precalc();

	curTime = 0;
	scanf("%d", &k);
	forn(i, k)
	{
		curTime++;
		forn(j, upd_cyc[curTime].sz)
		{
			int c = upd_cyc[curTime][j];
			if (cyc_time[c] == curTime)
			{
				update_cycle_on_tree(c);
			}
		}
		char cc;
		int x, y;
		scanf(" %c%d%d", &cc, &x, &y);
		if (cc == 'R')
		{
			x--;
			e[x][2] = y - curTime;
			update(x);
		}
		else if (cc == 'P')
		{
			x--;
			y--;
			PLI ans = solve(x, y);
			printf(INT64 "\n", ans.first + (i64)ans.second * curTime);
		}
	}

	return 0;
}
