#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second
//#define INF 1000000000000000001ll
#define INF 1000000001


#define floor flooor

#define NAME "b"

//#define int ll

struct Call
{
	int t, id, f;
	
	Call(int t, int id, int f): t(t), id(id), f(f) {}
	
	Call(): t(-1), id(-1), f(-1) {}
	
};

struct cmp_up
{
	bool operator () (const Call &a, const Call &b) const
	{
		if (a.f != b.f)
			return a.f < b.f;
		return mp(a.t, a.id) < mp(b.t, b.id);
	}
};

struct cmp_down
{
	bool operator () (const Call &a, const Call &b) const
	{
		if (a.f != b.f)
			return a.f > b.f;
		return mp(a.t, a.id) < mp(b.t, b.id);
	}
};

queue <Call> call;
int n, A, B;
int t, floor;
Call target;
queue <Call> q;
vector <int> ans;
set <Call, cmp_up> s_up;
set <Call, cmp_down> s_down;

void finish()
{
	for (int i = 0; i < sz(ans); ++i)
		cout << ans[i] << '\n';
	exit(0);
}

void add_call()
{
	Call c = call.front();
//	cerr << "add call " << c.id << '\n';
	q.push(c);
	s_up.insert(c);
	s_down.insert(c);
	call.pop();
}

void add_old_calls()
{
	while (!call.empty() && call.front().t < t)
		add_call();
}

void open_doors()
{
	assert(floor == target.f);
	ans[target.id] = t;
	t += A;
	add_old_calls();
}

void add_last_call()
{
	assert(!call.empty());
	if (floor == call.front().f)
	{
		target = call.front();
		call.pop();
		open_doors();
	}
	else
		add_call();
}

Call get_next_up()
{
	while (true)
	{
		auto it = s_up.lower_bound(Call(-1, -1, floor));
		assert(it != s_up.end());
		Call c = *it;
		if (ans[c.id] != -1)
		{
			s_up.erase(it);
			continue;
		}
		return c;
	}
}

Call get_next_down()
{
	while (true)
	{
		auto it = s_down.lower_bound(Call(-1, -1, floor));
		assert(it != s_down.end());
		Call c = *it;
		if (ans[c.id] != -1)
		{
			s_down.erase(it);
			continue;
		}
		return c;
	}
}

void set_target()
{
	while (!q.empty())
	{
		Call c = q.front();
		if (ans[c.id] != -1)
		{
			q.pop();
			continue;
		}
		target = c;
		return;
	}
	target = Call();
	return;
}

void move_elevator(int dt)
{
	if (target.f == -1)
	{
		t += dt;
		return;
	}
	int df = (dt + B - 1) / B;
	df = min(df, abs(target.f - floor));
	if (target.f > floor)
		floor += df;
	else
		floor -= df;
	dt = B * df;
	t += dt;
	add_old_calls();
}

void fix_target()
{
	if (target.id == -1)
		return;
	if (floor == target.f)
		return;
	if (floor > target.f)
	{
		Call c = get_next_down();
		assert(c.id != -1);
		target = c;
	}
	else
	{
		Call c = get_next_up();
		assert(c.id != -1);
		target = c;
	}
}

void go()
{
	set_target();
	fix_target();
	int t_call = INF;
	if (!call.empty())
		t_call = call.front().t - t;
	int t_target = INF;
	if (target.f != -1)
	{
		if (target.f == floor)
			t_target = 0;
		else
			t_target = abs(target.f - floor) * B - B + 1;
	}
	int dt = min(t_call, t_target);
	if (t_call != INF)
//		dt = min(dt, 1ll);
		dt = min(dt, 1);
	if (dt == INF)
	{
		finish();
		return;
	}
	if (dt == 0)
	{
		if (t_call == 0)
		{
			add_last_call();
			return;
		}
		if (t_target == 0)
		{
			open_doors();
			return;
		}
		assert(false);
		return;
	}
	move_elevator(dt);
}

//#undef int
int main()
{
//#define int ll
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	int m;
	cin >> n >> m >> A >> B;
	for (int i = 0; i < m; ++i)
	{
		ans.pb(-1);
		int t, f;
		cin >> t >> f;
		call.push(Call(t, i, f));
	}
	t = 0, floor = 1, target = Call();
	while (true)
		go();
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
