#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME "elevator"

int timerR = 0;

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(t--) {
		//++timerR;
	//cout << "Case #" << timerR << ": ";
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

int waitTime, moveTime;

vector<int> times;
vector<int> floors;

enum {
	IDLE = 0,
	WAIT = 1,
	MOVE = 2
};

struct Elevator {
	int state;
	int floor;
	int timeInState;
	Elevator(int state, int floor, int timeInState):state(state), floor(floor), timeInState(timeInState) {}

};

Elevator elevator(IDLE, 0, 120);

const li INF = 1e18;

struct Call {
	int id;
	int floor;
	Call(int id, int floor):id(id), floor(floor) {}
	bool operator < (const Call& ot) const {
		return id < ot.id;
	}
};

struct byFloor {
	bool operator () (const Call& a, const Call& b) const {
		return mp(a.floor, a.id) < mp(b.floor, b.id);
	}
};

set<Call> calls;

set<Call, byFloor> callsByFloor;

vector<set<Call>> floorCalls;

void addCall (int id) {
	calls.insert(Call(id, floors[id]));
	floorCalls[floors[id]].insert(Call(id, floors[id]));
	callsByFloor.insert(Call(id, floors[id]));
}

void eraseCall (Call cur) {
	calls.erase(cur);
	floorCalls[cur.floor].erase(cur);
	callsByFloor.erase(cur);
}

void solve() {

	int n, m;
	cin >> n >> m;

	floorCalls.resize(n);

	cin >> waitTime >> moveTime;

	times.resize(m);
	floors.resize(m);
	for (int i = 0; i < m; ++i) {
		cin >> times[i] >> floors[i];
		--floors[i];
	}

	int nextQuery = 0;

	li curTime = 0;

	vector<li> ans(m);

	while(nextQuery < m || elevator.state != IDLE) {

		li nextTime = ((nextQuery == m) ? INF : times[nextQuery]);

		if (elevator.state == IDLE) {
			if (floors[nextQuery] == elevator.floor) {
				elevator.state = WAIT;
				elevator.timeInState = 0;
				curTime = nextTime;
				ans[nextQuery] = curTime;
				++nextQuery;
				continue;
			}
			addCall(nextQuery++);
			elevator.state = MOVE;
			elevator.timeInState = 0;
			curTime = nextTime;
			continue;
		}

		if (elevator.state == WAIT) {

			if (nextTime - curTime >= waitTime - elevator.timeInState) {

				if (nextTime - curTime == waitTime - elevator.timeInState && nextQuery < m && elevator.floor == floors[nextQuery]) {
					ans[nextQuery] = nextTime;
					elevator.state = WAIT;
					elevator.timeInState = 0;
					curTime = nextTime;
					continue;
				}

				if (!calls.empty()) {
					Call cur = *calls.begin();
					if (cur.floor == elevator.floor) {
						eraseCall(cur);
						elevator.state = WAIT;
						elevator.timeInState = 0;
						curTime += waitTime - elevator.timeInState;
						ans[cur.id] = curTime;
						continue;
					}
					elevator.state = MOVE;
					curTime += waitTime - elevator.timeInState;
					elevator.timeInState = 0;
				}
				else {
					elevator.state = IDLE;
					curTime += waitTime - elevator.timeInState;
					elevator.timeInState = 0;
				}
				continue;
			}

			if (nextTime - curTime < waitTime - elevator.timeInState) {
				addCall(nextQuery++);
				elevator.timeInState += nextTime - curTime;
				continue;
			}
		}


		if (elevator.state == MOVE) {
			assert(!calls.empty());
			Call aim = *calls.begin();

			bool top = aim.floor > elevator.floor;

			int floorTo = -1;

			if (top) {
				auto it = callsByFloor.lower_bound(Call(INF, elevator.floor));
				assert (it != callsByFloor.end());
				floorTo = it->floor;
			}
			else {
				auto it = callsByFloor.lower_bound(Call(0, elevator.floor));
				assert (it != callsByFloor.begin());
				--it;
				floorTo = it->floor;
			}
			
			li needTime = abs(elevator.floor - floorTo) * moveTime - elevator.timeInState;

			if (nextTime - curTime >= needTime) {
				elevator.state = WAIT;
				elevator.floor = floorTo;
				elevator.timeInState = 0;
				curTime += needTime;
				Call done = *floorCalls[floorTo].begin();
				ans[done.id] = curTime;
				eraseCall(done);
				continue;
			}
			else {
				li sumTime = nextTime - curTime + elevator.timeInState;
				if (elevator.timeInState == 0 && elevator.floor == floors[nextQuery] && curTime == nextTime) {
					ans[nextQuery++] = curTime;
					elevator.state = WAIT;
					elevator.timeInState = 0;
				}
				else {
					addCall(nextQuery++);
					elevator.floor += sumTime / moveTime * ((top) ? 1 : -1);
					elevator.timeInState = sumTime % moveTime;
					curTime = nextTime;
				}
			}
		}
	}

	for (int i = 0; i < m; ++i)
		cout << ans[i] << "\n";

}