#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define lint long long
#define i64 long long
#define li long long
#define vi vector <int>
#define pb push_back

const int alpha = 26;

char table[] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};
#define SYMLEN 4

#define MAXN 1407

typedef int matrix[MAXN][MAXN];

matrix init;
matrix buf;

int N;

int numbers[MAXN * MAXN];
int sz[MAXN];

inline void transpose(matrix x) {
	for (int i = 0; i < N; i++)
		for (int j = 0; j < i; j++)
			swap(x[i][j], x[j][i]);
}

inline int mul(int a, int b) {
	//if (a == 1) return b;
	if (b == 1) return a;
	return 0;
}

inline void multiply_init(matrix a, matrix res) {
	for (int i = 0; i < N; i++) {
		int * aptr = a[i];
		for (int j = 0; j < N; j++) {
			int rr = 0;
			int * ptr = numbers + (j==0 ? 0: sz[j - 1]);
			int * ptrf = numbers + sz[j];
			for (; ptr != ptrf; ptr++) {
				rr += *(aptr + *ptr);
			}
			res[i][j] = rr;
		}
	}
}

inline void go(int & x, int & y) {
	y++;
	if (y == N) {
		x++;
		y = x + 1;
	}
}

matrix r1, r2;

int precalccnt[1 << 16];

int byte_cnt(int x) {
	int res = 0;
	for (int i = 0; i < 20; i++) {
		if (x & (1 << i))
			res++;
	}
	return res;
}

void matrix_convert(matrix a, matrix res) {
	memset(res, 0, sizeof res);
	for (int i = 0; i < N; i++) {
		for (int k = 0; k < N; k += (1 << 16)) {
			int c = 0;
			for (int cc = k; cc < k + 8; cc++)
				c |= a[i][cc] << (cc - k);
			res[i][k/8] = c;
		}
	}
}

void matrix_super_multiply(matrix a, matrix b, matrix res) {
	for (int i = 0; i < N; i++) {
		for (int j = 0; j < N; j++) {
			res[i][j] = 0;
			for (int k = 0; k < (N >> 16) + 1; k++)
				res[i][j] += precalccnt[a[i][k] & b[j][k]];
		}
	}
}


inline void fill_m(matrix x, char c, int & cx, int & cy) {
	int ii;
	for (ii = 0; ii < 16 && table[ii] != c; ii++) {}

	for (int i = 0; i < SYMLEN; i++) {
		x[cx][cy] = (ii >> (SYMLEN - 1 - i)) & 1;
		x[cy][cx] = 1 - ((ii >> (SYMLEN - 1 - i)) & 1);
		go(cx, cy);
	}
}

matrix d2, d3;

#include <ctime>

void solve(int test_number) {
	clock_t start = clock();
	int m;
	for (int i = 0; i < (1 << 16); i++)
		precalccnt[i] = byte_cnt(i);
	cin >> N >> m;
	int cx = 0, cy = 1;
	memset(init, 0, sizeof init);
	for (int i = 0; i < N * (N - 1) / 2; i += 4) {
		char x; cin >> x;
		fill_m(init, x, cx, cy);
	}
	memset(sz, 0, sizeof(sz));
	for (int j = 0; j < N; j++) {
		if (j != 0) sz[j] = sz[j - 1];
		for (int i = 0; i < N; i++) {
			if (init[i][j])
				numbers[sz[j]++] = i;
		}
	}
	/*for (int i = 0; i < N; i++) {
		for (int j = 0; j < N; j++) {
			cout << init[i][j] << " ";
		}
		cout << endl;
	}*/
	cerr << ((double)clock() - start) / CLOCKS_PER_SEC << endl;
	//multiply_init(init, d2);
	memcpy(buf, init, sizeof(matrix));
	transpose(buf);
	matrix_convert(init, r1);
	matrix_convert(buf, r2);
	matrix_super_multiply(r1, r2, d2);
	/*cout << endl;
	for (int i = 0; i < N; i++) {
		for (int j = 0; j < N; j++) {
			cout << d2[i][j] << " ";
		}
		cout << endl;
	}*/
	cerr << ((double)clock() - start) / CLOCKS_PER_SEC << endl;
	multiply_init(d2, d3);
	cerr << ((double)clock() - start) / CLOCKS_PER_SEC << endl;
	/*cout << endl;
	for (int i = 0; i < N; i++) {
		for (int j = 0; j < N; j++) {
			cout << d3[i][j] << " ";
		}
		cout << endl;
	}*/

	if (m == 3) {
		lint res = 0;
		for (int i = 0; i < N; i++) {
			for (int j = 0; j < N; j++) {
				if (i != j)
					res += d2[i][j] * init[j][i];
			}
		}
		cout << res / 3;
	} else if (m == 4) {
		lint res = 0;
		for (int i = 0; i < N; i++) {
			for (int j = 0; j < N; j++) {
				if (i != j)
					res += d2[i][j] * d2[j][i];
			}
		}
		cout << res / 4;
	} else if (m == 5) {
		lint res = 0;
		for (int i = 0; i < N; i++) {
			for (int j = 0; j < N; j++) {
				if (i != j)
					res += d2[i][j] * d3[j][i];
			}
		}
		cout << res / 5;
	}
	cerr << ((double)clock() - start) / CLOCKS_PER_SEC;
}

int main()
{
	freopen("deathstar.in", "r", stdin);
	freopen("deathstar.out", "w", stdout);
	//int tests;
	//scanf("%d", &tests);
	forn(test, 1)
		solve(test + 1);
}
