#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
typedef unsigned int uint;
const int N = 1400 + 35;
const int S = N / 32 + 1;
const int SHIFT = 16;
const int BASE = 11;
const int LOWEST = ((1 << BASE) - 1);
int path2[N][N], path3[N][N], bit_cnt[1 << SHIFT], sum[S][3][1 << BASE], n, m;
uint direct[N][S], inverse[N][S];
char s[N * N];
int64 res;

int get_bit_count(uint x) {
	return bit_cnt[x & ((1 << SHIFT) - 1)] + bit_cnt[x >> SHIFT];
}

void bset(uint * a, int b) {
	a[b >> 5] |= (1u << (b & 31));
}

int bget(uint* a, int b) {
	return (a[b >> 5] >> (b & 31)) & 1;
}

int bit_count_and(uint * a, uint * b) {
	int res = 0;
	for (int i = 0; i < S; ++i)
		res += get_bit_count(a[i] & b[i]);
	return res;
}

void add_edge(int u, int v) {
	bset(direct[u], v);
	bset(inverse[v], u);
}

int main() {
	/*assert(freopen("deathstar.in", "w", stdout));
	printf("1400 5\n");
	for (int i = 0; i < 1400 * 1400 / 8 + 1; ++i)
		printf("%c", '0' + rand() % 10);
	printf("\n");
	return 0;*/
	double start = clock();
	assert(freopen("deathstar.in", "r", stdin));
	assert(freopen("deathstar.out", "w", stdout));
	for (int i = 0; i < (1 << SHIFT); ++i)
		for (int j = 0; j < SHIFT; ++j)
			bit_cnt[i] += ((i >> j) & 1);
	scanf("%d%d%s", &n, &m, s);
	for (int i = 0, cur_i = 0, cur_j = 1; s[i]; ++i) {
		int digit = (('0' <= s[i]) && (s[i] <= '9')) ? (s[i] - '0') : (10 + s[i] - 'A');
		for (int j = 3; j >= 0; --j) {
			int bit = (digit >> j) & 1;
			if (bit) add_edge(cur_i, cur_j);
			else add_edge(cur_j, cur_i);
			cur_j++;
			if (cur_j == n) {
				cur_i++;
				cur_j = cur_i + 1;
			}
			if (cur_i == n - 1) break;
		}
		if (cur_i == n - 1) break;
	}
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j)
			path2[i][j] = bit_count_and(direct[i], inverse[j]);
	const int BLOCKS = n / 32 + 1;
	for (int i = 0; i < n; ++i) {
		memset(sum, 0, sizeof(sum));
		for (int block = 0; block < BLOCKS; ++block)
			for (int inner_block = 0; inner_block < 3; ++inner_block)
				for (int first_bit = 0, pos = (block << 5) + inner_block * BASE; first_bit < BASE; ++first_bit, ++pos)
					for (int k = (1 << first_bit), l = 0; k < (1 << (first_bit + 1)); ++k, ++l)
						sum[block][inner_block][k] = sum[block][inner_block][l] + path2[i][pos];
		for (int j = 0; j < n; ++j)
			for (int block = 0; block < BLOCKS; ++block) {
				unsigned int mask = inverse[j][block];
				path3[i][j] += sum[block][0][mask & LOWEST];
				path3[i][j] += sum[block][1][(mask >>= BASE) & LOWEST];
				path3[i][j] += sum[block][2][mask >> BASE];
			}
	}
	if (m == 3) {
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < n; ++j)
				if (bget(direct[i], j)) res += path2[j][i];
		res /= 3;
	} else if (m == 4) {
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < n; ++j)
				if (bget(direct[i], j)) res += path3[j][i];
		res /= 4;
	} else if (m == 5) {
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < n; ++j)
				if (i != j) res += path2[i][j] * (int64) path3[j][i];
		res /= 5;
	}
	printf("%lld\n", res);
	eprintf("%.2lf\n", (clock() - start) / CLOCKS_PER_SEC);
	return 0;
}