#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <ctime> 
#include <cctype> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

struct Event {
	int tim; 
	int nstate; 
	int nfloor; 
	int ind; 
	int typ; 
	int floor_call; 

	Event(int _t, int _nstate, int _nfloor, bool hui) {
		ind = -1; 
		tim = _t; 
		nstate = _nstate; 
		nfloor = _nfloor; 
		typ = 0; 
	}

	Event(int _tim, int _floor_call, int _ind) {
		tim = _tim;
		ind = _ind; 
		typ = 1; 
		floor_call = _floor_call; 
	}
};

bool operator < (const Event & a, const Event & b) {
	return a.tim < b.tim || (a.tim == b.tim && a.ind > b.ind); 
}

const int MOVING = 1; 
const int OPEN = 2; 
const int CLOSED = 3; 

int curstate = CLOSED; 
int t = 0; 
int floor = 1; 
bool needs_refill = 0; 
int nxt_time = 0; 

const int maxn = 500000; 

set <Event> queue; 
set <Event> events; 
vector<vector<int> > floors(maxn); 
vector<vector<Event> > floors2(maxn);
int A, B; 
int max_t_floor[maxn]; 
int ans[maxn]; 
int n, m; 



int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 

	scanf("%d %d %d %d", &n, &m, &A, &B); 
	for (int i = 0; i < m; i++) {
		int t, fl; 
		scanf("%d %d", &t, &fl); 
		events.insert(Event(t, fl, i)); 
	}

	while (1) {
		if (!queue.size() && !events.size()) {
			break; 
		}

		if (0 && events.size() == 1 && events.begin()->typ == 0 && events.begin()->nstate == CLOSED) {
			t = events.begin()->tim; 
			while (queue.size()) {
				Event q = *queue.begin(); 
				if (max_t_floor[q.floor_call] >= q.tim) {
					queue.erase(queue.begin()); 
				} else {
					break; 
				}
			}

			int curfloor = events.begin()->nfloor; 
			for (set<Event>::iterator it = queue.begin(); it != queue.end(); ++it) {
				floors2[it->floor_call].pb(*it); 
			}
			set<int> all; 

			for (int i = 1; i <= n; i++) {
				if (floors2[i].size() > 0) all.insert(i); 
			}

			while (queue.size()) {
				int nfl = queue.begin()->floor_call; 
				
				int dir = nfl > curfloor ? 1 : -1;
				all.insert(curfloor); 
				while (curfloor != nfl) {
					int told = t; 
					if ((floors2[curfloor].size())) {
						t += A; 
					}
					while (floors2[curfloor].size()) {
						ans[floors2[curfloor].back().ind] = told; 
						queue.erase(floors2[curfloor].back()); 
						floors2[curfloor].pop_back(); 
					}
					
					set<int>::iterator pos = all.lower_bound(curfloor);
					if (dir > 0) pos++; else pos--; 
					int next_floor = *pos; 
					t += B * abs(next_floor - curfloor); 
					
					all.erase(curfloor);
					curfloor = next_floor; 
				}
				int told = t; 
				if ((floors2[curfloor].size())) {
					t += A; 
				}
				while (floors2[curfloor].size()) {
					ans[floors2[curfloor].back().ind] = told; 
					queue.erase(floors2[curfloor].back()); 
					floors2[curfloor].pop_back(); 
				}
				all.erase(curfloor); 
			}

		}

		Event x = *events.begin(); 
		events.erase(events.begin()); 
		t = x.tim; 
		if (x.typ) {
			if (curstate == CLOSED && floor == x.floor_call) {
				curstate = OPEN; 
				events.insert(Event(t + A, CLOSED, floor, 1)); 
				nxt_time = t + A; 
				ans[x.ind] = t; 
			} else if (curstate == OPEN && floor == x.floor_call) {
				ans[x.ind] = t; 
				if (nxt_time == t) {
					needs_refill = 1; 
				}
			} else if (curstate == CLOSED && floor != x.floor_call) {
				curstate = MOVING; 
				queue.insert(x); 
				floors[x.floor_call].pb(x.ind); 
				events.insert(Event(t + B, CLOSED, floor + (x.floor_call - floor) / abs(x.floor_call - floor), 1)); 
			} else {
				queue.insert(x); 
				floors[x.floor_call].pb(x.ind); 
			}
		} else {
			curstate = x.nstate; 
			floor = x.nfloor; 
			if (needs_refill) {
				curstate = OPEN; 
				events.insert(Event(t + A, CLOSED, floor, 1));
				needs_refill = 0; 
				continue; 
			}

			if (floors[floor].size()) {
				max_t_floor[floor] = t; 
				for (int i = 0; i < floors[floor].size(); i++) {
					ans[floors[floor][i]] = t; 
				}
				floors[floor].clear(); 
				curstate = OPEN; 
				nxt_time = t + A; 
				events.insert(Event(t + A, CLOSED, floor, 1)); 
			} else {
				while (queue.size()) {
					Event q = *queue.begin(); 
					if (max_t_floor[q.floor_call] >= q.tim) {
						queue.erase(queue.begin()); 
					} else {
						if (q.floor_call == floor) {
							curstate = OPEN; 
							nxt_time = t + A; 
							events.insert(Event(t + A, CLOSED, floor, 1)); 
							ans[x.ind] = t; 
						} else {
							curstate = MOVING; 
							events.insert(Event(t + B, CLOSED, floor + (q.floor_call - floor) / abs(q.floor_call - floor), 1 )); 
							break; 
						}
					}
				}
			}
		}
		
	}

	for (int i = 0; i < m; i++) {
		printf("%d\n", ans[i]); 
	}

	return 0;
}