#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const ll inf = ll(1e17);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = int(1e5) + 100;

struct rmq {

	int maxv;
	ll val[4 * N];

	inline void init(int sz) {
		maxv = 1;
		while (maxv < sz) {
			maxv *= 2;
		}
		for (int i = 1; i < 2 * maxv; ++i) {
			val[i] = inf;
		}
	}

	inline void update(int pos, ll val) {
		pos += maxv;
		this->val[pos] = val;
		while (pos > 1) {
			pos /= 2;
			this->val[pos] = min(this->val[pos * 2], this->val[pos * 2 + 1]);
		}
	}

	int get_pos_left(int v, int gl, int gr, int l, int r, ll need_val) {
		if (gl > r || gr < l) {
			return -1;
		}
		if (gl >= l && gr <= r) {
			if (v >= maxv) {
				if (val[v] > need_val) {
					return -1;
				}
				return v - maxv;
			}
			if (val[v * 2] <= need_val) {
				return get_pos_left(v * 2, gl, (gl + gr) / 2, l, r, need_val);
			}
			return get_pos_left(v * 2 + 1, (gl + gr) / 2 + 1, gr, l, r, need_val);
		}
		int res = get_pos_left(v * 2, gl, (gl + gr) / 2, l, r, need_val);
		if (res != -1) {
			return res;
		}
		return get_pos_left(v * 2 + 1, (gl + gr) / 2 + 1, gr, l, r, need_val);
	}

	inline int get_pos_left(int l, int r, ll val) {
		return get_pos_left(1, 0, maxv - 1, l, r, val);
	}

	int get_pos_right(int v, int gl, int gr, int l, int r, ll need_val) {
		if (gl > r || gr < l) {
			return -1;
		}
		if (gl >= l && gr <= r) {
			if (v >= maxv) {
				if (val[v] > need_val) {
					return -1;
				}
				return v - maxv;
			}
			if (val[v * 2 + 1] <= need_val) {
				return get_pos_right(v * 2 + 1, (gl + gr) / 2 + 1, gr, l, r, need_val);
			}
			return get_pos_right(v * 2, gl, (gl + gr) / 2, l, r, need_val);
		}
		int res = get_pos_right(v * 2 + 1, (gl + gr) / 2 + 1, gr, l, r, need_val);
		if (res != -1) {
			return res;
		}
		return get_pos_right(v * 2, gl, (gl + gr) / 2, l, r, need_val);
	}

	inline int get_pos_right(int l, int r, ll val) {
		return get_pos_right(1, 0, maxv - 1, l, r, val);
	}

};

int cur_f, A, B, m;
ll cur_time;
rmq r1, r2;
pii a[N];
int t[N], f[N];
ll ans[N];
set<pii> q;

inline int get_left(int f) {
	return lower_bound(a, a + m, mp(f, -int(1e9))) - a;
}

inline int get_right(int f) {
	return upper_bound(a, a + m, mp(f, int(1e9))) - a - 1;
}

inline int get_pos(int from, int to) {
	int pos = -1;
	if (from <= to) {
		pos = r1.get_pos_left(get_left(from), get_right(to), cur_time - from * B);
	} else {
		swap(from, to);
		pos = r2.get_pos_right(get_left(from), get_right(to), cur_time + to * B);
	}
	return pos;
}

inline pii remove_pos(int pos) {
	int num = a[pos].sc;
	q.erase(mp(t[num], num));
	r1.update(pos, inf);
	r2.update(pos, inf);
	return mp(t[num], num);
}

inline void walk(int from, int to) {
	do {
		int pos = get_pos(from, to);
		assert(pos != -1);
		if (from != a[pos].fs) {
			cur_time += abs(a[pos].fs - from) * B;
			from = a[pos].fs;
		}
		set<pii> s;
		for (;;) {
			for (;;) {
				pos = get_pos(from, to);
				if (pos == -1 || a[pos].fs != from) {
					break;
				}
				s.insert(remove_pos(pos));
			}
			if (s.empty()) {
				break;
			}
			int num = s.begin()->sc;
			s.erase(s.begin());
			ans[num] = cur_time;
			cur_time += A;
		}
	} while (from != to);
}

int main() {
#ifdef LOCAL42
#define TASK "B"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int n;
	scanf("%d %d %d %d", &n, &m, &A, &B);
	for (int i = 0; i < m; ++i) {
		scanf("%d %d", &t[i], &f[i]);
		--f[i];
		a[i] = mp(f[i], i);
		q.insert(mp(t[i], i));
	}
	sort(a, a + m);
	r1.init(m);
	r2.init(m);
	for (int i = 0; i < m; ++i) {
		int num = a[i].sc;
		r1.update(i, t[num] - f[num] * B);
		r2.update(i, t[num] + f[num] * B);
	}
	int cur_f = 0;
	cur_time = 0;
	while (!q.empty()) {
		int go = f[q.begin()->sc];
		cur_time = max(cur_time, 1LL * q.begin()->fs);
		walk(cur_f, go);
		cur_f = go;
	}
	for (int i = 0; i < m; ++i) {
		printf(LLD "\n", ans[i]);
	}
	return 0;
}