#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <assert.h>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

int n, m, a, b;
vector <pair <int, int> > queries;
//vector <int> answer;

struct Event {
  int x, time, num;
  Event() {}
  Event(int x, int time, int num) : x(x), time(time), num(num) {}

  bool operator<(Event const &e) const {
    if (x == e.x) {
      if (time == e.time) {
        return num < e.num;
      }
      return time < e.time;
    }
    return x < e.x;
  }
};

vector <int> solve() {
  //vector <pair <int, bool> > current;
  //vector <pair <int, int> > toAdd;
  vector <int> answer(m, -1);

  vector <pair <int, int> >::iterator notAdded = queries.begin();

  int currCoord = 0, currTime = 0;
  map<int, queue<int>> events;
  //set <Event> events;
//  set <Event> toDelete;
//  set <int> visitedFloors;

  for (int i = 0; i != m; ++i) {
    if (answer[i] != -1) continue;

    currTime = max(currTime, queries[i].first);
    int end = currTime + abs(currCoord - queries[i].second) * b;

    while (notAdded != queries.end() && notAdded->first <= end) {
      events[notAdded->second].push(notAdded - queries.begin());
      notAdded++;
    }

    if (currCoord == queries[i].second) {
      assert(events[queries[i].second].front() == i);
      events[queries[i].second].pop();
      if (events[queries[i].second].empty()) {
        events.erase(queries[i].second);
      }
      answer[i] = end;
      currTime = end + a;
      continue;
    }

    int dir = queries[i].second > currCoord ? 1 : -1;
    map<int, queue<int>>::iterator begin;

    if (dir == 1) {
      begin = events.lower_bound(currCoord);
    } else {
      begin = prev(events.upper_bound(currCoord));
    }

    while (begin->first != queries[i].second) {
      while (!begin->second.empty()) {
        int q = begin->second.front();
        if (abs(currCoord - queries[q].second) * b + currTime >= queries[q].first) {
          answer[q] = abs(currCoord - queries[q].second) * b + currTime;
          begin->second.pop();
          currTime += a;
          end += a;
          while (notAdded != queries.end() && notAdded->first <= end) {
            events[notAdded->second].push(notAdded - queries.begin());
            notAdded++;
          }
        } else {
          break;
        }
      }

      auto old = begin;
      if (dir == 1) {
        ++begin;
      } else {
        --begin;
      }
      if (old->second.empty()) {
        events.erase(old);
      }
    }

    assert(begin->second.front() == i);
    begin->second.pop();
    if (begin->second.empty()) {
      events.erase(begin);
    }
    answer[i] = end;
    currCoord = queries[i].second;
    currTime = end + a;
  }

  return answer;
}

void input() {
  cin >> n >> m >> a >> b;
  queries.resize(m);

  for (auto it = queries.begin(); it != queries.end(); ++it) {
    cin >> it->first >> it->second;
    --it->second;
  }
}

void input_debug() {
  n = rand() % 100;
  m = rand() % 100;
  a = rand() % 100;
  b = rand() % 100;
  queries.resize(m);

  for (auto it = queries.begin(); it != queries.end(); ++it) {
    it->first = rand() % 1000;
    it->second = rand() % n;
  }
}

int main() {
  std::ios_base::sync_with_stdio(false);

  input();
  vector<int> answer = solve();
  for (int i = 0; i < answer.size(); i++) {
    cout << answer[i] << "\n";
  }

  return 0;
}
