#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <functional>
#include <climits>
#include <stack>
#include <cassert>

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ABS(a) (((a) > 0) ? (a) : (-(a)))
#define ZERO(x) memset((x), 0, sizeof(x))
#define NEGATE(x) memset((x), 255, sizeof(x))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> ii;
typedef pair<int, pair<int, int> > iii;
typedef pair<ll, ll> pl;

const int N = 1e5 + 100;
const int M = 1e5 + 100;
const int T = 1e5 + 100;

ii calls_descr[M]; // [call_index] = (time, floor)
vector<ii> calls[T];    // [time][k] = (floor, call_index)
queue<int> curcalls[N]; // [floor][k] = (call_index)
set<int> que; // (call_index)
int ans[M];

int n, m;
int a, b;

int time;

enum State
{
	STOPPED = 0,
	START_MOVE,
	MOVE,
	WAIT
};

struct Elevator
{
	State state;
	int pos;
	int moving;
	int waiting;
	int target;
	int curcl;
	bool got;

	Elevator() : state(STOPPED), pos(0), moving(0), waiting(0), target(-1), curcl(-1), got(false)
	{
	}

	void next()
	{
		
		if (state == STOPPED)
		{
			if (!que.empty())
			{
				set<int>::iterator it = que.begin();
				target = calls_descr[*it].second;
				curcl = *it;
				que.erase(it);
				state = START_MOVE;
			}
		}

		start_move:
		if (state == START_MOVE)
		{

			if (!curcalls[pos].empty())
			{
				int cl = curcalls[pos].front();
				curcalls[pos].pop();
				que.erase(cl);
				ans[cl] = time;
				state = WAIT;
				waiting = a;
				if (cl == curcl)
				{
					curcl = -1;
				}
			}
			else
			{
				if (curcl == -1)
				{
					if (!que.empty())
					{
						set<int>::iterator it = que.begin();
						target = calls_descr[*it].second;
						curcl = *it;
						que.erase(it);
						state = START_MOVE;
					}
					else
					{
						state = STOPPED;
					}
				}
				else
				{
					moving = b;
					state = MOVE;
				}
			}

		}

		if (state == MOVE)
		{
			if (moving == 0)
			{
				state = START_MOVE;
				if (target > pos)
				{
					++pos;
				}
				else
				{
					--pos;
				}
				goto start_move;
			}
			--moving;

		}

		if (state == WAIT)
		{
			
			--waiting;
			if (waiting == 0)
			{
				state = START_MOVE;
				goto start_move;
			}

		}
	}
	
};

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

	cin >> n >> m;
	cin >> a >> b;
	
	for (int i = 0; i < m; i++)
	{
		int t, f;
		cin >> t >> f;
		--f;
		calls[t].push_back(mp(f,i));
		calls_descr[i] = mp(t, f);
	}

	Elevator el;
	for (time = 0; time <= 2e7 + 100; time++)
	{
		if (time < T)
		{
			if (!calls[time].empty())
			{
				for (int k = 0; k < calls[time].size(); ++k)
				{
					int to = calls[time][k].first;
					int ind = calls[time][k].second;
					curcalls[to].push(ind);
					que.insert(ind);
				}
			}
		}

		el.next();
	}

	for (int i = 0; i < m; ++i)
	{
		printf("%d\n", ans[i]);
	}

    return 0;
}