#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <limits.h>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <utility>
#include <stdio.h>
#include <time.h>
#include <memory.h>
#include <string.h>
#include <assert.h>
using namespace std;

#define EPS 1E-4
const long long MOD = 1000000007;
#define mp make_pair

struct pt {
	long double x,y,z;
	void read(){
		cin>>x>>y>>z;
	}
	pt operator-(const pt&a) {
		pt res;
		res.x = x-a.x;
		res.y = y-a.y;
		res.z = z-a.z;
		return res;
	}
	pt operator-() {
		pt res;
		res.x = -x;
		res.y = -y;
		res.z = -z;
		return res;
	}
	pt operator+(const pt&a) {
		pt res;
		res.x = x+a.x;
		res.y = y+a.y;
		res.z = z+a.z;
		return res;
	}
	pt operator*(const pt&a) {
		pt res;
		res.x = y*a.z-z*a.y;
		res.y = -(x*a.z - z*a.x);
		res.z = x*a.y - y*a.x;
		return res;
	}
	pt operator*(const double&a) {
		pt res;
		res.x = x*a;
		res.y = y*a;
		res.z = z*a;
		return res;
	}
	long double len() {
		return sqrt((*this)%(*this));
	}
	void norm() {
		long double lenn = this->len();
		x/=lenn;
		y/=lenn;
		z/=lenn;
	}
	long double operator%(const pt&a) const{
		return x*a.x + y*a.y + z*a.z;
	}
};

struct pt2{
	long double x,y;
	double operator*(const pt2&a) {
		return this->x*a.y - this->y*a.x;
	}
	pt2 operator*(const double a) {
		pt2 res;
		res.x = x*a;
		res.y = y*a;
		return res;
	}
	double operator%(const pt2&a) {
		return this->x*a.x + this->y*a.y;
	}
	pt2 operator-(const pt2&a) {
		pt2 res;
		res.x = this->x-a.x;
		res.y = this->y-a.y;
		return res;
	}
	pt2 operator+(const pt2&a) {
		pt2 res;
		res.x = this->x+a.x;
		res.y = this->y+a.y;
		return res;
	}
	pt2 rotate(){
		pt2 res;
		res.x = y;
		res.y = -x;
		return res;
	}
};

long double mix(pt a, pt b, pt c){
	return (a%(b*c));
}

pt O;
vector<pt>cube1(8);
vector<pt>cube2(8);

vector<pt>make_cube(){
	vector<pt>res(8);
	for(int i=0; i<4; ++i){
		res[i].read();
	}
	res[4]=res[1]+res[2]-res[0];
	res[5]=res[1]+res[3]-res[0];
	res[6]=res[3]+res[2]-res[0];
	res[7]=res[4]+res[5]-res[1];
	return res;
}

pair<bool, pt> intersect(pt a, pt b, pt c, pt o, pt o1){
	//a,b,c = plane
	//p1,p2 - looch

	long double down = mix((o1-o),(b-a),(c-a));
	if(fabs(down) < EPS){
		return make_pair(false, a);
	}

	long double up = mix(a-o1, b-a, c-a);

	long double t = up/down;
	if(t<EPS){
		return make_pair(false, a);
	}
	pt res = (o1-o)*t;
	return make_pair(true, res+o1);
}

bool check(pt a, pt b, pt c, pt o, pt o1){
	long double down = mix((o1-o),(b-a),(c-a));
	if(fabs(down) < EPS){
		return false;
	}

	long double up = mix(a-o1, b-a, c-a);
	long double t = up/down;
	return !(t<EPS || t>1.-EPS);
}

pt2 base;

bool cmp(pt2 a, pt2 b){
	return (a-base)*(b-base) > 0;
}

bool seg_intersection(pt2 a, pt2 b, pt2 c, pt2 d, pt2 & res){
	long double up = (c-a)*(d-c).rotate();
	long double dn = (b-a)*(d-c).rotate();
	if(fabs(dn) < EPS){
		return false;
	}
	long double t = up/dn;

	if(t>=1 || t<0){
		return false;
	}

	long double up1 = (a-c)*(b-a).rotate();
	long double dn1 = (d-c)*(b-a).rotate();

	if(fabs(dn1) < EPS){
		return false;
	}
	long double t1 = up1/dn1;

	if(t1>=1 || t1<0){
		return false;
	}

	res = (b-a)*t + a;
	return true;
}

void uni(vector<pt2>vec){
	vector<pt2>tmp;
	for(int i=0; i<vec.size(); ++i){
		for(int j=i+1; j<vec.size(); ++j){
			if(fabs(vec[i].x-vec[j].x)<EPS && fabs(vec[i].y-vec[j].y)<EPS){
				tmp.push_back(vec[i]);
			}
		}
	}
	vec=tmp;
}


vector<pt2> getConv(vector<pt2>&vec){
	vector<pt2>vec1,vec2;
	bool ok;
	for(int i=0; i<vec.size(); ++i){
		ok=true;
		for(int j=i+1; j<vec.size(); ++j){
			if(fabs(vec[i].x-vec[j].x)<1E-9 && fabs(vec[i].y-vec[j].y)<1E-9){
				ok=false;
				break;
			}
		}
		if(ok){
			vec1.push_back(vec[i]);
		}
	}
	vector<pt2>emp;
	if(vec1.size()<3){
		return emp;
	}
	stack<pt2>st;
	int Leftmost = -1;
	for(int i=0; i<vec1.size(); ++i){
		if(Leftmost==-1 || (vec1[i].x < vec1[Leftmost].x)){
			Leftmost = i;
		}
	}
	base = vec1[Leftmost];
	
	vec1.erase(vec1.begin()+Leftmost);

	for(int i=0;i<vec1.size(); ++i){
		int rbound = i;
		for(int j=i+1; j<vec1.size() && fabs((vec1[i]-base)*(vec1[j]-base))<EPS; ++j){
			rbound++;
		}
		pt2 toadd = vec1[i];
		for(int j=i+1; j<=rbound; ++j){
			if((toadd-base)%(toadd-base) < EPS + (vec1[j]-base)%(vec1[j]-base)){
				toadd = vec1[j];
			}
		}
		vec2.push_back(toadd);
		i=rbound;
	}

	sort(vec2.begin(), vec2.end(), cmp);
	st.push(base);
	st.push(vec2[0]);
	pt2 prev, pprev;
	for(int i=1; i<vec2.size(); ++i){
		prev = st.top();
		st.pop();
		pprev = st.top();
		st.push(prev);
		while(st.size() > 1 && (prev-pprev)*(vec2[i]-prev) < 0){
			st.pop();
			if(st.size() == 1){
				break;
			}
			prev=pprev;
			st.pop();
			pprev = st.top();
			st.push(prev);
		}
		st.push(vec2[i]);
	}
	vector<pt2>conv(st.size());
	for(int i=0; i<conv.size(); ++i){
		conv[i]=st.top();
		st.pop();
	}
	return conv;
}

long double getconvarea(vector<pt2>pts){
	vector<pt2>conv = getConv(pts);
	long double res = 0;
	for(int i=1; i<=conv.size(); ++i){
		res += (conv[i%(int)conv.size()]-conv[0])*(conv[i-1]-conv[0]);
	}
	return fabs(res/2);
}


long double shshsh(pt p1, pt p2, pt p3){
	vector<pt2>pts;
	pair<bool,pt>crr;
	for(int i=0; i<cube1.size(); ++i){
		crr = intersect(p1,p2,p3,O,cube1[i]);
		if(crr.first){
			pt2 currpt;
			currpt.x = (crr.second-p1)%(p2-p1)/(p2-p1).len();
			currpt.y = (crr.second-p1)%(p3-p1)/(p2-p1).len();
			pts.push_back(currpt);
		}
	}
	if(pts.size()<3)return 0;
	uni(pts);
	vector<pt2>conv=getConv(pts);
	vector<pt2>mycube(4);
	long double lenn=(p2-p1).len();
	mycube[0].x=0;
	mycube[0].y=0;
	mycube[1].x=0;
	mycube[1].y=lenn;
	mycube[2].x=lenn;
	mycube[2].y=lenn;
	mycube[3].x=lenn;
	mycube[3].y=0;

	vector<pt2>conv1;

	for(int i=0; i<conv.size(); ++i){
		if((conv[i].x >= 0 && conv[i].x <= 1 && conv[i].y >= 0 && conv[i].y <= 1)){
			conv1.push_back(conv[i]);
		}
	}

	for(int i=1; i<=conv.size(); ++i){
		for(int j=1; j<=4; ++j){
			pt2 inter;
			if(seg_intersection(conv[i-1],conv[i%conv.size()],mycube[j%4],mycube[j-1],inter)){
				conv1.push_back(inter);
			}
		}
	}

	for(int i=0; i<4; ++i){
		int cnt1=0,cnt2=0;
		for(int j=1; j<=conv.size(); ++j){
			if((conv[j%conv.size()]-mycube[i])*(conv[j-1]-mycube[i])>=-EPS){
				cnt1++;
			}
			else{
				cnt2++;
			}
		}
		if(!cnt1 || !cnt2){
			conv1.push_back(mycube[i]);
		}
	}

	uni(conv1);
	return getconvarea(conv1);
}

	
long double shadow(){
	pt center2=cube2[0];
	for(int i=1; i<cube2.size(); ++i){
		center2=center2+cube2[i];
	}
	center2 = center2 * (1./8);

	double result = 0;


	pt p1,p2,p3;

	p1=cube2[0];
	p2=cube2[1];
	p3=cube2[2];

	if(check(p1,p2,p3,O,center2)){
		result += shshsh(p1,p2,p3);
	}

	p1=cube2[0];
	p2=cube2[1];
	p3=cube2[3];
	
	if(check(p1,p2,p3,O,center2)){
		result += shshsh(p1,p2,p3);
	}

	p1=cube2[0];
	p2=cube2[2];
	p3=cube2[3];

	if(check(p1,p2,p3,O,center2)){
		result += shshsh(p1,p2,p3);
	}

	p1=cube2[1];
	p2=cube2[4];
	p3=cube2[5];

	if(check(p1,p2,p3,O,center2)){
		result += shshsh(p1,p2,p3);
	}

	p1=cube2[2];
	p2=cube2[4];
	p3=cube2[6];

	if(check(p1,p2,p3,O,center2)){
		result += shshsh(p1,p2,p3);
	}

	p1=cube2[3];
	p2=cube2[5];
	p3=cube2[6];
	
	if(check(p1,p2,p3,O,center2)){
		result += shshsh(p1,p2,p3);
	}
	return result;
}

int main(){
	freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);

	O.read();

	cube1=make_cube();
	cube2=make_cube();

	long double res1 = shadow();
	swap(cube1,cube2);
	long double res2 = shadow();

	if(res1 < EPS && res2 < EPS){
		puts("-1");
		return 0;
	}

	if(res1 < EPS){
		printf("1 %.3lf", res2);
	}
	else{
		printf("2 %.3lf", res1);
	}

	return 0;
}