#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<li,li> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

//#define TASK_NAME ""

int n, m;
int a, b;
const int N = 100005;
set<pt> call;
pt query[N];

bool read() {
	if (scanf("%d%d%d%d", &n, &m, &a, &b) != 4)
		return false;
	forn (i, m)
	{
		int x, y;
		scanf("%d%d", &x, &y);
		query[i] = mp(x, y);
	}
	return true;
}

int ans[N];

bool inRange(li l, li r, li a)
{
	return a >= l && a <= r || a >= r && a <= l;
}

li getTime(li x, li y)
{
	return abs(x - y) * abs(b); 
}

int lastFloor = 0;

void go(li floor, li time)
{
	set<pt>::iterator it = call.lower_bound(mp(floor, -1));
	if(it != call.end() && it->ft == floor)
	{
		ans[it->sc] = time;
		set<pt>::iterator nit = it;
		nit++;
		call.erase(it);
		it = nit;
	}
}


li nextFloor(li floor, li target)
{
	if (floor == target)
		return floor;
	if (floor < target)
	{
		set<pt>::iterator it = call.lower_bound(mp(floor, -1));
		return it->ft;
	}
	else
	{
		set<pt>::iterator it = call.lower_bound(mp(floor, INF));
		it--;
		return it->ft;
	}
}

set<pair<li, pt> > ass;

void solve() {
	forn (i, N)
		ans[i] = -1;

	li ct = 0;
	query[m++] = mp(1e18, 1);

	int floor = 1;
	queue<pt> q;

	int l = 0;
	while(l < m)
	{
		while(!q.empty() && ans[q.front().sc] != -1)
			q.pop();
		while(!ass.empty() && ass.begin()->ft <= ct)
		{
			call.insert(ass.begin()->sc);
			ass.erase(ass.begin());
		}

		if (!q.empty())
		{
			int target = q.front().ft;
			int run = min(li(query[l].ft) - ct, getTime(nextFloor(floor, target), floor));
			if (getTime(floor, target) <= run)
			{
				ct += getTime(floor, target);
				floor = target;
				q.pop();
				go(floor, ct);
				ct += a;
			}
			else
			{
				while(l < m && query[l].ft - ct == run)
				{
					q.push(mp(query[l].sc, l));
					if (getTime(floor, query[l].sc) < query[l].ft - ct)
						ass.insert(mp(query[l].ft, mp(query[l].sc, l)));
					else
						call.insert(mp(query[l].sc, l));
					l++;
				}
				if (getTime(nextFloor(floor, target), floor) == run)
				{
					ct += run;
					floor = nextFloor(floor, target);
					go(floor, ct);
					ct += a;
				}
			}
		}
		else
		{
			ct = max(ct, query[l].ft);
			q.push(mp(query[l].sc, l));
			call.insert(mp(query[l].sc, l));
			l++;
		}
	}

	forn (i, m - 1)
		cout << ans[i] << endl;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	while (read())
		solve();

	return 0;
}