#include <iostream>
#include <queue>
#include <climits>
#include <list>

using namespace std;

int n, m, a, b;

list<pair<int, int>> floorCalls[100005];
int result[100005];
const int N = 1 << 17;
pair<int, int> T[3][2 * N];
const int beforeBegin = 0;
const int pastEnd = 2 * N - 1;

void updateFloor(int f) {
	for(int s = 0; s < 3; ++s) {
		int v = f + N;
		if(floorCalls[f].empty()) {
			T[s][v] = make_pair(INT_MAX, INT_MAX);
		} else {
			T[s][v] = make_pair(floorCalls[f].front().first + (s - 1) * b * f, floorCalls[f].front().second);
		}
		v >>= 1;
		while(v) {
			T[s][v] = min(T[s][2 * v], T[s][2 * v + 1]);
			v >>= 1;
		}
	}
}

void addFloorCall(int f, int t, int i) {
	floorCalls[f].emplace_back(t, i);
	
	if(floorCalls[f].size() == 1) {
		updateFloor(f);
	}
}

pair<int, pair<int, int>> getCall() {
	if(T[1][1].first == INT_MAX) return make_pair(-1, make_pair(-1, -1));
	
	int v = 1;
	while(v < N) {
		v *= 2;
		if(T[1][v + 1] < T[1][v]) ++v;
	}
	v -= N;
	auto ret = make_pair(v, floorCalls[v].front());
	floorCalls[v].pop_front();
	updateFloor(v);
	return ret;
}

pair<int, int> getCallUp(int lo, int hi, int lotime) {
	int xd = lotime - lo * b;
	int v = lo + N;
	while(T[0][v].first > xd) {
		if(v & 1) {
			if(!((v + 1) & v)) return make_pair(-1, -1);
			++v;
		} else {
			v >>= 1;
		}
	}
	while(v < N) {
		v *= 2;
		if(T[0][v].first > xd) ++v;
	}
	v -= N;
	if(v >= hi) return make_pair(-1, -1);
	int asd = floorCalls[v].front().second;
	floorCalls[v].pop_front();
	updateFloor(v);
	return make_pair(v, asd);
}
pair<int, int> getCallDown(int lo, int hi, int hitime) {
	int xd = hitime + hi * b;
	int v = hi + N;
	while(T[2][v].first > xd) {
		if(!(v & 1)) {
			if(!((v - 1) & v)) return make_pair(-1, -1); 
			--v;
		} else {
			v >>= 1;
		}
	}
	while(v < N) {
		v *= 2;
		if(T[0][v + 1].first <= xd) ++v;
	}
	v -= N;
	if(v <= lo) return make_pair(-1, -1);
	int asd = floorCalls[v].front().second;
	floorCalls[v].pop_front();
	updateFloor(v);
	return make_pair(v, asd);
}

int main() {
	for(int s = 0; s < 3; ++s) {
		fill(T[s], T[s] + 2 * N, make_pair(INT_MAX, INT_MAX));
		T[s][N + beforeBegin] = make_pair(INT_MAX, INT_MAX);
	}
	
	cin.sync_with_stdio(false);
	cin >> n >> m >> a >> b;
	
	for(int i = 0; i < m; ++i) {
		int t, f;
		cin >> t >> f;
		addFloorCall(f, t, i);
	}
	
	int time = 0;
	int pos = 1;
	
	while(true) {
		auto p = getCall();
		if(p.first == -1) break;
		int floor = p.first;
		int rtime = p.second.first;
		int asd = p.second.second;
		if(rtime > time) time = rtime;
		if(floor == pos) {
			result[asd] = time;
			time += a;
		} else if(floor > pos) {
			while(true) {
				auto p = getCallUp(pos, floor, time);
				if(p.first == -1) break;
				int v = p.first;
				int asd = p.second;
				time += b * (v - pos);
				pos = v;
				result[asd] = time;
				time += a;
			}
			time += b * (floor - pos);
			pos = floor;
			result[asd] = time;
			time += a;
		} else {
			while(true) {
				auto p = getCallDown(floor, pos, time);
				if(p.first == -1) break;
				int v = p.first;
				int asd = p.second;
				time += b * (pos - v);
				pos = v;
				result[asd] = time;
				time += a;
			}
			time += b * (pos - floor);
			pos = floor;
			result[asd] = time;
			time += a;
		}
	}
	for(int i = 0; i < m; ++i) {
		cout << result[i] << "\n";
	}
	
	return 0;
}
