#include <iostream>
#include <cstdio>
#include <cassert>
#include <vector>
#include <algorithm>
#include <memory.h>
#include <queue>
#include <set>
 
using namespace std;

typedef long long ll;

const int maxn = 1 << 17;
const int maxm = 16;

int n, m, a, b;
int t[maxn], f[maxn];
ll ans[maxn];
queue<int> q[maxn];

int main() {
	freopen("elevator.in", "r", stdin);

	cin >> n >> m >> a >> b;
	for (int i = 0; i < m; i++) {
		cin >> t[i] >> f[i];
		ans[i] = -1;
	}
	ans[m] = -1;
	t[m] = -1;

	int curElevatorFloor = 1;
	ll whenAvailable = 0;
	int curPassenger = 0;
	int finishedPassengers = 0;
	ll curTime = 0;
	for (curTime = 0; curTime < 2e5; curTime++) {
		whenAvailable = max(whenAvailable, curTime);
		while (t[curPassenger] == curTime) {
			q[f[curPassenger]].push(curPassenger);
			curPassenger++;
		}
		if (whenAvailable > curTime) continue;
		//if (curTime > 1e5) break;
		if (curPassenger == m) break;
		while (ans[finishedPassengers] != -1) finishedPassengers++;
		if (finishedPassengers == m || t[finishedPassengers] > curTime) continue;
		int targetFloor = f[finishedPassengers];
		if (!q[curElevatorFloor].empty()) {
			int v = q[curElevatorFloor].front();
			q[curElevatorFloor].pop();
			ans[v] = curTime;
			whenAvailable += a;
		}
		if (targetFloor > curElevatorFloor) {
			whenAvailable += b;
			curElevatorFloor++;
		} else if (targetFloor < curElevatorFloor) {
			whenAvailable += b;
			curElevatorFloor--;			
		}
	}
	
	set<pair<int, int> > st;

	for (int i = 0; i < m; i++) {
		if (ans[i] == -1) {
			st.insert(make_pair(f[i], i));
		}
	}

	
	while (!st.empty()) {
		while (ans[finishedPassengers] != -1) finishedPassengers++;
		int targetFloor = f[finishedPassengers];		

		if (targetFloor < curElevatorFloor) {
			set<pair<int, int> > :: iterator it = st.lower_bound(make_pair(curElevatorFloor + 1, -1));
			it--;
			it = st.lower_bound(make_pair(it->first, -1));
			int nextFloor = it->first;
			if (it->first == curElevatorFloor) {
				int v = it->second;
				it--;
				nextFloor = it->first;
				st.erase(++it);
				ans[v] = curTime;
				curTime += a;
			}
			curTime += 1LL * b * (curElevatorFloor - nextFloor);
			curElevatorFloor = nextFloor;
		} else if (targetFloor == curElevatorFloor) {
			set<pair<int, int> > :: iterator it = st.lower_bound(make_pair(curElevatorFloor, -1));
			ans[it->second] = curTime;
			curTime += a;
			st.erase(it);
		} else if (targetFloor > curElevatorFloor) {
			set<pair<int, int> > :: iterator it = st.lower_bound(make_pair(curElevatorFloor, -1));
			int nextFloor = it->first;
			if (it->first == curElevatorFloor) {
				int v = it->second;
				nextFloor = st.lower_bound(make_pair(it->first + 1, -1))->first;
				st.erase(it);
				ans[v] = curTime;
				curTime += a;
			}
			curTime += 1LL * b * (nextFloor - curElevatorFloor);
			curElevatorFloor = nextFloor;
		}
	}
	for (int i = 0; i < m; i++) cout << ans[i] << endl;

	return 0;
}